use> ?Set{ada,bob,cyd,dan}.name
     Bag{'Ada','Bob','Cyd','Dan'} : Bag(String)

use> ?Person.allInstances.name
     Bag{'Ada','Bob','Cyd','Dan'} : Bag(String)

use> ?Set{ada,bob,cyd,dan}->collect(name)
     Bag{'Ada','Bob','Cyd','Dan'} : Bag(String)

use> ?Set{ada,bob,cyd,dan}->collect(p|p.name)
     Bag{'Ada','Bob','Cyd','Dan'} : Bag(String)

use> ?Set{ada,bob,cyd,dan}->collectNested(Sequence{name,civstat,gender,alive})
     Bag{Sequence{'Ada',#widowed, #female,true },
         Sequence{'Bob',#divorced,#male,  true },
         Sequence{'Cyd',#married, #male,  false},
         Sequence{'Dan',#single,  #male,  true }} : Bag(Sequence(OclAny))

use> ?Set{ada,bob,cyd,dan}->
       collectNested(p|Sequence{p.name,p.civstat,p.gender,p.alive})
     Bag{Sequence{'Ada',#widowed, #female,true },
         Sequence{'Bob',#divorced,#male,  true },
         Sequence{'Cyd',#married, #male,  false},
         Sequence{'Dan',#single,  #male,  true }}: Bag(Sequence(OclAny))

use> ?Person.allInstances->forAll(p1,p2|p1<>p2 implies p1.name<>p2.name)
     true : Boolean

use> ?Person.allInstances->isUnique(p|p.name)
     true : Boolean

use> ?Person.allInstances->forAll(p|
       (p.gender=#female implies p.wife->isEmpty) and
       (p.gender=#male implies p.husband->isEmpty))
     true : Boolean

use> ?Person.allInstances->
       select(p|p.alive and p.civstat<>#widowed).civstat
     Bag{#divorced,#single} : Bag(CivilStatus)

use> ?let p1=Person.allInstances->any(true) in
      let p2=Person.allInstances->excluding(p1)->any(true) in
      let p3=Person.allInstances->excluding(p1)->
               excluding(p2)->any(true) in
      let p4=Person.allInstances->excluding(p1)->
               excluding(p2)->excluding(p3)->any(true) in
      Sequence{p1,p2,p3,p4}=Person.allInstances->asSequence()
     true : Boolean

use> ?let o:OclAny=ada in o
     ada : Person

use> ?Person.allInstances->iterate(w,h:Person;
       res:Set(Tuple(bride:Person,bridegroom:Person))=
         oclEmpty(Set(Tuple(bride:Person,bridegroom:Person)))|
       if w.gender=#female and h.gender=#male and
          w.alive and h.alive and
          w.civstat<>#married and h.civstat<>#married then
          res->including(Tuple{bride:w,bridegroom:h})
       else res endif)
     Set{Tuple{bride:ada,bridegroom:bob},
         Tuple{bride:ada,bridegroom:dan}} :
     Set(Tuple(bride:Person,bridegroom:Person))

use> ?Sequence{ada.name,ada.civstat,ada.alive,ada.gender,
               dan.name,dan.civstat,dan.alive,dan.gender}
     Sequence{'Ada',#widowed,true,#female,'Dan',#single,true,#male} :
     Sequence(OclAny)

use> !set dan.civstat:=#married
use> !set ada.civstat:=#married
use> !insert (ada,dan) into Marriage

use> ?Sequence{ada,ada.spouse(),dan,dan.spouse()}
     Sequence{ada,dan,dan,ada} : Sequence(Person)

use> ?Sequence{ada,ada.spouse(),ada.spouse().spouse(),
               ada.spouse().spouse().spouse()}
     Sequence{ada,dan,ada,dan} : Sequence(Person)

use> ?Person.allInstances->
       select(husband=Person.allInstances->any(wife->isEmpty).wife)
     Set{bob,cyd,dan} : Set(Person)
