-- Collection Operations

-- -- Iterate

-- -- -- collect

-- -- -- -- Empty

-- -- -- -- -- Set ------------------------------------------------

?let c = oclEmpty(Set(Integer)) in 
   c->collect(i|i*i) = 
     c->iterate(i; r:Bag(Integer) = oclEmpty(Bag(Integer)) | 
           r->including(i*i))

Expected Results:
  true : Boolean

-- -- -- -- -- Bag

?let c = oclEmpty(Bag(Integer)) in 
   c->collect(i|i*i) = 
     c->iterate(i; r:Bag(Integer) = oclEmpty(Bag(Integer)) | 
           r->including(i*i))

Expected Results:
  true : Boolean

-- -- -- -- -- Sequence A

?let c = oclEmpty(Sequence(Integer)) in 
   c->collect(i|i*i) = 
     c->iterate(i;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) |
           r->including(i*i))

Expected Results:
  true : Boolean

-- -- -- -- -- Sequence B

?let c = oclEmpty(Sequence(Integer)) in 
   c->collect(i|i*i) = 
     c->iterate(i; 
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->append(i*i))

Expected Results:
  true : Boolean

-- -- -- -- Singleton

-- -- -- -- -- Includes Undefined

-- -- -- -- -- -- Set ---------------------------------------------

?let c = Set{oclUndefined(Integer)} in 
   c->collect(i|i*i) = 
     c->iterate(i; r:Bag(Integer) = oclEmpty(Bag(Integer)) | 
           r->including(i*i))

Expected Results:
  true : Boolean

-- -- -- -- -- -- Bag

?let c = Bag{oclUndefined(Integer)} in 
   c->collect(i|i*i) = 
     c->iterate(i; r:Bag(Integer) = oclEmpty(Bag(Integer)) | 
           r->including(i*i))

Expected Results:
  true : Boolean

-- -- -- -- -- -- Sequence A

?let c = Sequence{oclUndefined(Integer)} in 
   c->collect(i|i*i) = 
     c->iterate(i;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->including(i*i))

Expected Results:
  true : Boolean

-- -- -- -- -- -- Sequence B

?let c = Sequence{oclUndefined(Integer)} in 
   c->collect(i|i*i) = 
     c->iterate(i; 
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) |
           r->append(i*i))
     false : Boolean

-- -- -- -- -- Excludes Undefined

-- -- -- -- -- -- Set ---------------------------------------------

?let c = Set{2} in 
   c->collect(i|i*i) = 
     c->iterate(i; r:Bag(Integer) = oclEmpty(Bag(Integer)) | 
           r->including(i*i))

Expected Results:
  true : Boolean

-- -- -- -- -- -- Bag

?let c = Bag{2} in 
   c->collect(i|i*i) = 
     c->iterate(i; r:Bag(Integer) = oclEmpty(Bag(Integer)) | 
           r->including(i*i))

Expected Results:
  true : Boolean

-- -- -- -- -- -- Sequence A

?let c = Sequence{2} in 
   c->collect(i|i*i) = 
     c->iterate(i; 
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->including(i*i))

Expected Results:
  true : Boolean

-- -- -- -- -- -- Sequence B

?let c = Sequence{2} in 
   c->collect(i|i*i) = 
     c->iterate(i; 
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) |
           r->append(i*i))

Expected Results:
  true : Boolean

-- -- -- -- Many Elements

-- -- -- -- -- Includes Undefined

-- -- -- -- -- -- Set ---------------------------------------------

?let c = Set{oclUndefined(Integer), 0, 1, 2} in 
   c->collect(i|i*i) = 
     c->iterate(i; r:Bag(Integer) = oclEmpty(Bag(Integer)) | 
           r->including(i*i))

Expected Results:
  true : Boolean

-- -- -- -- -- -- Bag

-- -- -- -- -- -- -- Equal Values

?let c = Bag{oclUndefined(Integer), 0, 1, 2, 
                  oclUndefined(Integer)} in 
   c->collect(i|i*i) = 
     c->iterate(i; r:Bag(Integer) = oclEmpty(Bag(Integer)) | 
           r->including(i*i))

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- No Equal Values

?let c = Bag{oclUndefined(Integer), 0, 1, 2} in 
   c->collect(i|i*i) = 
     c->iterate(i; r:Bag(Integer) = oclEmpty(Bag(Integer)) | 
           r->including(i*i))

Expected Results:
  true : Boolean

-- -- -- -- -- -- Sequence A

-- -- -- -- -- -- -- Equal Values

?let c = Sequence{oclUndefined(Integer), 0, 1, 2, 
                       oclUndefined(Integer)} in 
   c->collect(i|i*i) = 
     c->iterate(i;r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->including(i*i))

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- No Equal Values

?let c = Sequence{oclUndefined(Integer), 0, 1, 2} in 
   c->collect(i|i*i) = 
     c->iterate(i;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->including(i*i))

Expected Results:
  true : Boolean

-- -- -- -- -- -- Sequence B

-- -- -- -- -- -- -- Equal Values

?let c = Sequence{oclUndefined(Integer), 0, 1, 2, 
                       oclUndefined(Integer)} in 
   c->collect(i|i*i) = 
     c->iterate(i;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) |
           r->append(i*i))
     false : Boolean

-- -- -- -- -- -- -- No Equal Values

?let c = Sequence{oclUndefined(Integer), 0, 1, 2} in 
   c->collect(i|i*i) = 
     c->iterate(i;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) |
           r->append(i*i))
     false : Boolean

-- -- -- -- -- Excludes Undefined

-- -- -- -- -- -- Set ---------------------------------------------

?let c = Set{-1, 0, 1, 2} in 
   c->collect(i|i*i) = 
     c->iterate(i; r:Bag(Integer) = oclEmpty(Bag(Integer)) | 
           r->including(i*i))

Expected Results:
  true : Boolean

-- -- -- -- -- -- Bag

-- -- -- -- -- -- -- Equal Values

?let c = Bag{-1, 0, 1, 2, 1} in 
   c->collect(i|i*i) = 
     c->iterate(i; r:Bag(Integer) = oclEmpty(Bag(Integer)) | 
           r->including(i*i))

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- No Equal Values

?let c = Bag{-1, 0, 1, 2} in 
   c->collect(i|i*i) = 
     c->iterate(i; r:Bag(Integer) = oclEmpty(Bag(Integer)) | 
           r->including(i*i))

Expected Results:
  true : Boolean

-- -- -- -- -- -- Sequence A

-- -- -- -- -- -- -- Equal Values

?let c = Sequence{-1, 0, 1, 2, 1} in 
   c->collect(i|i*i) = 
     c->iterate(i;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->including(i*i))

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- No Equal Values

?let c = Sequence{-1, 0, 1, 2} in 
   c->collect(i|i*i) = 
     c->iterate(i; 
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->including(i*i))

Expected Results:
  true : Boolean

-- -- -- -- -- -- Sequence B

-- -- -- -- -- -- -- Equal Values

?let c = Sequence{-1, 0, 1, 2, 1} in 
   c->collect(i|i*i) = 
     c->iterate(i;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) |
           r->append(i*i))

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- No Equal Values

?let c = Sequence{-1, 0, 1, 2} in 
   c->collect(i|i*i) = 
     c->iterate(i;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) |
           r->append(i*i))

Expected Results:
  true : Boolean
