-- Technical Relationships

-- -- Determinateness Constraints

-- -- -- In Addition to the Ocl4All 2007 equivalences

-- -- -- -- Empty

-- -- -- -- -- Set -----------------------------------------------------

?let c = oclEmpty(Set(Integer)) in
   c->any(true) = c->asBag()->any(true)

Expected Results:
  true : Boolean

?let c = oclEmpty(Set(Integer)) in
   c->any(true) = c->asSequence()->any(true)

Expected Results:
  true : Boolean

?let c = oclEmpty(Set(Integer)) in
   c->any(true) = c->asBag()->asSequence()->any(true)

Expected Results:
  true : Boolean

?let c = oclEmpty(Set(Integer)) in
   c->any(true) = c->asSequence()->first()

Expected Results:
  true : Boolean

?let c = oclEmpty(Set(Integer)) in
   c->any(true) = c->asSequence()->last()

Expected Results:
  true : Boolean

?let c = oclEmpty(Set(Integer)) in
   c->any(true) = c->asBag()->asSequence()->first()

Expected Results:
  true : Boolean

?let c = oclEmpty(Set(Integer)) in
   c->any(true) = c->asBag()->asSequence()->last()

Expected Results:
  true : Boolean

?let c = oclEmpty(Set(Integer)) in
   c->any(true) = 
     c->iterate(elem;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) |
           r->including(elem))->first()

Expected Results:
  true : Boolean

?let c = oclEmpty(Set(Integer)) in
       Sequence{c}->flatten() = c->asSequence()

Expected Results:
  true : Boolean

?let c = oclEmpty(Set(Integer)) in
       Sequence{c}->flatten() = c->asBag()->asSequence()

Expected Results:
  true : Boolean

-- -- -- -- -- Bag

?let c = oclEmpty(Bag(Integer)) in
   c->asSequence() = 
     c->iterate(elem;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->including(elem))

Expected Results:
  true : Boolean

?let c = oclEmpty(Bag(Integer)) in
   c->any(true) = c->asSequence()->any(true)

Expected Results:
  true : Boolean

?let c = oclEmpty(Bag(Integer)) in
   c->any(true) = c->asSequence()->first()

Expected Results:
  true : Boolean

?let c = oclEmpty(Bag(Integer)) in
   c->any(true) = c->asSequence()->last()

Expected Results:
  true : Boolean

?let c = oclEmpty(Bag(Integer)) in
   c->any(true) = 
     c->iterate(elem;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->including(elem))->first()

Expected Results:
  true : Boolean

?let c = oclEmpty(Bag(Integer)) in
       Sequence{c}->flatten() = c->asSequence()

Expected Results:
  true : Boolean

-- -- -- -- -- Sequence

-- -- -- -- Singleton

-- -- -- -- -- Includes Undefined

-- -- -- -- -- -- Set --------------------------------------------------

?let c = Set{oclUndefined(Integer)} in
   c->any(true) = c->asBag()->any(true)

Expected Results:
  true : Boolean

?let c = Set{oclUndefined(Integer)} in
   c->any(true) = c->asSequence()->any(true)

Expected Results:
  true : Boolean

?let c = Set{oclUndefined(Integer)} in
   c->any(true) = c->asBag()->asSequence()->any(true)

Expected Results:
  true : Boolean

?let c = Set{oclUndefined(Integer)} in
   c->any(true) = c->asSequence()->first()

Expected Results:
  true : Boolean

?let c = Set{oclUndefined(Integer)} in
   c->any(true) = c->asSequence()->last()

Expected Results:
  true : Boolean

?let c = Set{oclUndefined(Integer)} in
   c->any(true) = c->asBag()->asSequence()->first()

Expected Results:
  true : Boolean

?let c = Set{oclUndefined(Integer)} in
   c->any(true) = c->asBag()->asSequence()->last()

Expected Results:
  true : Boolean

?let c = Set{oclUndefined(Integer)} in
   c->any(true) = 
     c->iterate(elem;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) |
           r->including(elem))->first()

Expected Results:
  true : Boolean

?let c = Set{oclUndefined(Integer)} in
       Sequence{c}->flatten() = c->asSequence()

Expected Results:
  true : Boolean

?let c = Set{oclUndefined(Integer)} in
       Sequence{c}->flatten() = c->asBag()->asSequence()

Expected Results:
  true : Boolean

-- -- -- -- -- -- Bag

?let c = Bag{oclUndefined(Integer)} in
   c->asSequence() = 
     c->iterate(elem;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->including(elem))

Expected Results:
  true : Boolean

?let c = Bag{oclUndefined(Integer)} in
   c->any(true) = c->asSequence()->any(true)

Expected Results:
  true : Boolean

?let c = Bag{oclUndefined(Integer)} in
   c->any(true) = c->asSequence()->first()

Expected Results:
  true : Boolean

?let c = Bag{oclUndefined(Integer)} in
   c->any(true) = c->asSequence()->last()

Expected Results:
  true : Boolean

?let c = Bag{oclUndefined(Integer)} in
   c->any(true) = 
     c->iterate(elem;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->including(elem))->first()

Expected Results:
  true : Boolean

?let c = Bag{oclUndefined(Integer)} in
       Sequence{c}->flatten() = c->asSequence()

Expected Results:
  true : Boolean

-- -- -- -- -- -- Sequence

-- -- -- -- -- Excludes Undefined

-- -- -- -- -- -- Set -----------------------------------------------

?let c = Set{1} in
   c->any(true) = c->asBag()->any(true)

Expected Results:
  true : Boolean

?let c = Set{1} in
   c->any(true) = c->asSequence()->any(true)

Expected Results:
  true : Boolean

?let c = Set{1} in
   c->any(true) = c->asBag()->asSequence()->any(true)

Expected Results:
  true : Boolean

?let c = Set{1} in
   c->any(true) = c->asSequence()->first()

Expected Results:
  true : Boolean

?let c = Set{1} in
   c->any(true) = c->asSequence()->last()

Expected Results:
  true : Boolean

?let c = Set{1} in
   c->any(true) = c->asBag()->asSequence()->first()

Expected Results:
  true : Boolean

?let c = Set{1} in
   c->any(true) = c->asBag()->asSequence()->last()

Expected Results:
  true : Boolean

?let c = Set{1} in
   c->any(true) = 
     c->iterate(elem;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->including(elem))->first()

Expected Results:
  true : Boolean

?let c = Set{1} in
       Sequence{c}->flatten() = c->asSequence()

Expected Results:
  true : Boolean

?let c = Set{1} in
       Sequence{c}->flatten() = c->asBag()->asSequence()

Expected Results:
  true : Boolean

-- -- -- -- -- -- Bag

?let c = Bag{1} in
   c->asSequence() = 
     c->iterate(elem;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->including(elem))

Expected Results:
  true : Boolean

?let c = Bag{1} in
   c->any(true) = c->asSequence()->any(true)

Expected Results:
  true : Boolean

?let c = Bag{1} in
   c->any(true) = c->asSequence()->first()

Expected Results:
  true : Boolean

?let c = Bag{1} in
   c->any(true) = c->asSequence()->last()

Expected Results:
  true : Boolean

?let c = Bag{1} in
   c->any(true) = 
     c->iterate(elem;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->including(elem))->first()

Expected Results:
  true : Boolean

?let c = Bag{1} in
       Sequence{c}->flatten() = c->asSequence()

Expected Results:
  true : Boolean

-- -- -- -- -- -- Sequence

-- -- -- -- Many Elements

-- -- -- -- -- Includes Undefined

-- -- -- -- -- -- Set --------------------------------------------------

?let c = Set{oclUndefined(Integer), 1, -1, 3, 2, 0} in
   c->any(true) = c->asBag()->any(true)
     false : Boolean

?let c = Set{oclUndefined(Integer), 1, -1, 3, 2, 0} in
   c->any(true) = c->asSequence()->any(true)

Expected Results:
  true : Boolean

?let c = Set{oclUndefined(Integer), 1, -1, 3, 2, 0} in
   c->any(true) = c->asBag()->asSequence()->any(true)
     false : Boolean

?let c = Set{oclUndefined(Integer), 1, -1, 3, 2, 0} in
   c->any(true) = c->asSequence()->first()

Expected Results:
  true : Boolean

?let c = Set{oclUndefined(Integer), 1, -1, 3, 2, 0} in
   c->any(true) = c->asSequence()->last()
     false : Boolean

?let c = Set{oclUndefined(Integer), 1, -1, 3, 2, 0} in
   c->any(true) = c->asBag()->asSequence()->first()
     false : Boolean

?let c = Set{oclUndefined(Integer), 1, -1, 3, 2, 0} in
   c->any(true) = c->asBag()->asSequence()->last()

Expected Results:
  true : Boolean

?let c = Set{oclUndefined(Integer), 1, -1, 3, 2, 0} in
   c->any(true) = 
     c->iterate(elem;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->including(elem))->first()

Expected Results:
  true : Boolean

?let c = Set{oclUndefined(Integer), 1, -1, 3, 2, 0} in
       Sequence{c}->flatten() = c->asSequence()

Expected Results:
  true : Boolean

?let c = Set{oclUndefined(Integer), 1, -1, 3, 2, 0} in
       Sequence{c}->flatten() = c->asBag()->asSequence()
     false : Boolean

-- -- -- -- -- -- Bag

-- -- -- -- -- -- -- Equal Values

?let c = Bag{oclUndefined(Integer), 1, -1, 3, 2, 0, 
                  oclUndefined(Integer)} in
   c->asSequence() = 
     c->iterate(elem;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->including(elem)
)

Expected Results:
  true : Boolean

?let c = Bag{oclUndefined(Integer), 1, -1, 3, 2, 0, 
                  oclUndefined(Integer)} in
   c->any(true) = c->asSequence()->any(true)

Expected Results:
  true : Boolean

?let c = Bag{oclUndefined(Integer), 1, -1, 3, 2, 0, 
                  oclUndefined(Integer)} in
   c->any(true) = c->asSequence()->first()

Expected Results:
  true : Boolean

?let c = Bag{oclUndefined(Integer), 1, -1, 3, 2, 0, 
                  oclUndefined(Integer)} in
   c->any(true) = c->asSequence()->last()
     false : Boolean

?let c = Bag{oclUndefined(Integer), 1, -1, 3, 2, 0, 
                  oclUndefined(Integer)} in
   c->any(true) = 
     c->iterate(elem;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->including(elem))->first()

Expected Results:
  true : Boolean

?let c = Bag{oclUndefined(Integer), 1, -1, 3, 2, 0, 
                  oclUndefined(Integer)} in
       Sequence{c}->flatten() = c->asSequence()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- No Equal Values

?let c = Bag{oclUndefined(Integer), 1, -1, 3, 2, 0} in
   c->asSequence() = 
     c->iterate(elem;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->including(elem))

Expected Results:
  true : Boolean

?let c = Bag{oclUndefined(Integer), 1, -1, 3, 2, 0} in
   c->any(true) = c->asSequence()->any(true)

Expected Results:
  true : Boolean

?let c = Bag{oclUndefined(Integer), 1, -1, 3, 2, 0} in
   c->any(true) = c->asSequence()->first()

Expected Results:
  true : Boolean

?let c = Bag{oclUndefined(Integer), 1, -1, 3, 2, 0} in
   c->any(true) = c->asSequence()->last()
     false : Boolean

?let c = Bag{oclUndefined(Integer), 1, -1, 3, 2, 0} in
   c->any(true) = 
     c->iterate(elem;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->including(elem))->first()

Expected Results:
  true : Boolean

?let c = Bag{oclUndefined(Integer), 1, -1, 3, 2, 0} in
       Sequence{c}->flatten() = c->asSequence()

Expected Results:
  true : Boolean

-- -- -- -- -- -- Sequence

-- -- -- -- -- -- -- Equal Values

-- -- -- -- -- -- -- No Equal Values

-- -- -- -- -- Excludes Undefined

-- -- -- -- -- -- Set -----------------------------------------------

?let c = Set{1, -1, 3, 2, 0} in
   c->any(true) = c->asBag()->any(true)
     false : Boolean

?let c = Set{1, -1, 3, 2, 0} in
   c->any(true) = c->asSequence()->any(true)

Expected Results:
  true : Boolean

?let c = Set{1, -1, 3, 2, 0} in
   c->any(true) = c->asBag()->asSequence()->any(true)
     false : Boolean

?let c = Set{1, -1, 3, 2, 0} in
   c->any(true) = c->asSequence()->first()

Expected Results:
  true : Boolean

?let c = Set{1, -1, 3, 2, 0} in
   c->any(true) = c->asSequence()->last()
     false : Boolean

?let c = Set{1, -1, 3, 2, 0} in
   c->any(true) = c->asBag()->asSequence()->first()
     false : Boolean

?let c = Set{1, -1, 3, 2, 0} in
   c->any(true) = c->asBag()->asSequence()->last()

Expected Results:
  true : Boolean

?let c = Set{1, -1, 3, 2, 0} in
   c->any(true) = 
     c->iterate(elem;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->including(elem))->first()

Expected Results:
  true : Boolean

?let c = Set{1, -1, 3, 2, 0} in
       Sequence{c}->flatten() = c->asSequence()

Expected Results:
  true : Boolean

?let c = Set{1, -1, 3, 2, 0} in
       Sequence{c}->flatten() = c->asBag()->asSequence()
     false : Boolean

-- -- -- -- -- -- Bag

-- -- -- -- -- -- -- Equal Values

?let c = Bag{1, -1, 3, 2, 0, 1} in
   c->asSequence() = 
     c->iterate(elem;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->including(elem))

Expected Results:
  true : Boolean

?let c = Bag{1, -1, 3, 2, 0, 1} in
   c->any(true) = c->asSequence()->any(true)

Expected Results:
  true : Boolean

?let c = Bag{1, -1, 3, 2, 0, 1} in
   c->any(true) = c->asSequence()->first()

Expected Results:
  true : Boolean

?let c = Bag{1, -1, 3, 2, 0, 1} in
   c->any(true) = c->asSequence()->last()
     false : Boolean

?let c = Bag{1, -1, 3, 2, 0, 1} in
   c->any(true) = 
     c->iterate(elem;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->including(elem))->first()

Expected Results:
  true : Boolean

?let c = Bag{1, -1, 3, 2, 0, 1} in
       Sequence{c}->flatten() = c->asSequence()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- No Equal Values

?let c = Bag{1, -1, 3, 2, 0} in
   c->asSequence() = 
     c->iterate(elem;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->including(elem))

Expected Results:
  true : Boolean

?let c = Bag{1, -1, 3, 2, 0} in
   c->any(true) = c->asSequence()->any(true)

Expected Results:
  true : Boolean

?let c = Bag{1, -1, 3, 2, 0} in
   c->any(true) = c->asSequence()->first()

Expected Results:
  true : Boolean

?let c = Bag{1, -1, 3, 2, 0} in
   c->any(true) = c->asSequence()->last()
     false : Boolean

?let c = Bag{1, -1, 3, 2, 0} in
   c->any(true) = 
     c->iterate(elem;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->including(elem))->first()

Expected Results:
  true : Boolean

?let c = Bag{1, -1, 3, 2, 0} in
       Sequence{c}->flatten() = c->asSequence()

Expected Results:
  true : Boolean

-- -- -- -- -- -- Sequence

-- -- -- -- -- -- -- Equal Values

-- -- -- -- -- -- -- No Equal Values

