-------------------------------------------------------------------
-- Identifiers in this file have been shortened -------------------
-------------------------------------------------------------------
-- Build truth tables for boolean connectives ---------------------
-------------------------------------------------------------------
?Sequence{1..16}->iterate(i:Integer;
   res:Sequence(Sequence(Boolean))=
     Set{false,true,oclUndefined(Boolean)}->iterate(b1,b2:Boolean;
       res:Sequence(Sequence(Boolean))=
       oclEmpty(Sequence(Sequence(Boolean)))|
       res->including(Sequence{b1,b2,not(b1),b1 and b2,
         b1 or b2,b1 xor b2,b1 implies b2,b1=b2,b1<>b2}))|res)

Expected Result:
  Sequence{
    Sequence{Undef,Undef,Undef,Undef,Undef,Undef,Undef,true, false},
    Sequence{Undef,false,Undef,false,Undef,Undef,Undef,false,true },
    Sequence{Undef,true, Undef,Undef,true, Undef,true, false,true },
    Sequence{false,Undef,true, false,Undef,Undef,true, false,true },
    Sequence{false,false,true, false,false,false,true, true, false},
    Sequence{false,true, true, false,true, true, true, false,true },
    Sequence{true, Undef,false,Undef,true, Undef,Undef,false,true },
    Sequence{true, false,false,false,true, true, false,false,true },
    Sequence{true, true, false,true, true, false,true, true, false}} :
  Sequence(Sequence(Boolean))

-------------------------------------------------------------------
-- Invert a long string -------------------------------------------
-------------------------------------------------------------------
?let base:String='0123456789'.concat('abcdefghijklmnopqrstuvwxyz').
   concat('ABCDEFGHIJKLMNOPQRSTUVWXYZ') in
 let count:Integer=16 in
 let longstr:String=Set{1..count}->iterate(
   i:Integer;res:String=''|res.concat(base)) in
 Set{1..longstr.size()}->iterate(i:Integer;res:String=''|
   res.concat(longstr.
     substring(longstr.size()+1-i,longstr.size()+1-i)))
     
Expected Result:
  'ZYX ... 210' : String

-------------------------------------------------------------------
-- Compute all prime numbers up to a given upper bound ------------
-------------------------------------------------------------------

?Sequence{1..2048}->iterate(i:Integer;res:Sequence(Integer)=
   oclEmpty(Sequence(Integer))|
     if m.isPrime(i) then res->including(i) else res endif)
     
Expected Result:
  Sequence{2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,
           73,79,83,89,97, ..., 2003,2011,2017,2027,2029,2039} :
  Sequence(Integer)

?Sequence{1..16}->iterate(i;res:Sequence(Sequence(OclAny))=
   oclEmpty(Sequence(Sequence(OclAny)))|
   res->including(Sequence{i,m.isPrime(i)}))->select(last()=true)

Expected Result:
  Sequence{Sequence{2,true},Sequence{3,true},Sequence{5,true},
           Sequence{7,true},Sequence{11,true},Sequence{13,true}} :
  Sequence(Sequence(OclAny))

-------------------------------------------------------------------
-- Compute the root of 10.89 with precision 1/10^16 ---------------
-------------------------------------------------------------------

?Set{1..16}->iterate(i;res:Real=
  m.root(10.89,
         1/(10*10*10*10*10*10*10*10*10*10*10*10*10*10*10*10))|res)
         
Expected Result:
  3.300000000066939 : Real

-------------------------------------------------------------------
-- USE and Java are already bad in computing 3.3*3.3=10.89 --------
-------------------------------------------------------------------
?3.3*3.3

Expected Result:
  10.889999999999999 : Real
